; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_INITIALISIERUNG:
; SPI-SCK			
	cbi (SPI_SCK_DDR) ,(SPI_SCK_PIN_NR)		; auf EINGANG	
	sbi (SPI_SCK_PORT),(SPI_SCK_PIN_NR)		; PULL-UP-ON	
; SPI-CS			
	cbi (SPI_CS_DDR) , (SPI_CS_PIN_NR)		; auf EINGANG	
	sbi (SPI_CS_PORT), (SPI_CS_PIN_NR)		; PULL-UP-ON	
; Kanal-A			
	cbi (SPI_A_DDR) ,(SPI_A_PIN_NR)			; auf EINGANG	
;	sbi (SPI_A_PORT),(SPI_A_PIN_NR)			; PULL-UP-ON	
; Kanal-B			
	cbi (SPI_B_DDR) ,(SPI_B_PIN_NR)			; auf EINGANG	
;	sbi (SPI_B_PORT),(SPI_B_PIN_NR)			; PULL-UP-ON	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI:
;-------------------------------------------------------------------------------
; warten, bis CS HIGH wird														
	WDR
	sbis (SPI_CS_PIN),(SPI_CS_PIN_NR)		; CS HIGH ?		
	rjmp SPI
;-------------------------------------------------------------------------------
; Next Bytes																	
SPI_NEXT_BYTE:
	ldi BIT_COUNTER,8
SPI_NEXT_BYTE_w:
	WDR
	sbic (SPI_CS_PIN),(SPI_CS_PIN_NR)		; CS LOW ?		
	rjmp SPI_NEXT_BYTE_w
;-------------------------------------------------------------------------------
; Next Bit																		
SPI_NEXT_BIT:
	WDR
	sbic (SPI_SCK_PIN),(SPI_SCK_PIN_NR); warten, bis SCK wieder LOW wird
	rjmp SPI_NEXT_BIT
;-------------------------------------------------------------------------------
SPI_CLK_HIGH:
	WDR
	sbis (SPI_SCK_PIN),(SPI_SCK_PIN_NR); warten, bis SCK wieder HIGH wird
	rjmp SPI_CLK_HIGH
;-------------------------------------------------------------------------------
;  SAMPELS A																	
	cbi (LED_TEST_PORT),(LED_TEST_PIN_NR)	; TEST an	
	CLC										; Clear Carry	
	sbic (SPI_A_PIN),(SPI_A_PIN_NR)			; A LOW ?		
	SEC										; Set Carry		
	ROL BYTE_A 								; links ber Carry
;-------------------------------------------------------------------------------
;  SAMPELS B																	
	CLC										; Clear Carry	
	sbic (SPI_B_PIN),(SPI_B_PIN_NR)			; B LOW ?		
	SEC										; Set Carry		
	ROL BYTE_B 								; links ber Carry
	sbi (LED_TEST_PORT),(LED_TEST_PIN_NR)	; TEST aus	
;-------------------------------------------------------------------------------
; ERROR																			
	sbic (SPI_CS_PIN),(SPI_CS_PIN_NR)		; CS LOW ?		
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT 	an		
;-------------------------------------------------------------------------------
; BIT-COUNTER																	
	dec BIT_COUNTER
	brne SPI_NEXT_BIT 
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR		; GELB an	
;-------------------------------------------------------------------------------
; Bytesuche	(z.B. IP-Adresse)													
;	cpi BYTE_A,192		; A	
;	breq SPI_FREIGABE
;	cpi BYTE_B,192		; B	
;	breq SPI_FREIGABE
;	rjmp SPI_FREIGABE_CHECK
;SPI_FREIGABE:
;	mov FREIGABE_SRAM,EINS
;SPI_FREIGABE_CHECK:
;	tst FREIGABE_SRAM
;	breq SPI_NEXT_BYTE
;-------------------------------------------------------------------------------
; SAVE																			
	 ST Z+,BYTE_A
	 ST Z+,BYTE_B
;-------------------------------------------------------------------------------
	; fertig ?				
	cpi ZL,LOW (adr_SPI_DATENBEREICH+1000)
	brne SPI_NEXT_BYTE
	cpi ZH,HIGH(adr_SPI_DATENBEREICH+1000)
	brne SPI_NEXT_BYTE
	breq SPI_STOP
ret
;-------------------------------------------------------------------------------
; SPI STOP !																	
SPI_STOP:
	mov FREIGABE_USART,EINS
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



